#ifndef __STDBSI_H
#define __STDBSI_H
//
//  (C) Copyright 1993-2008 by Autodesk, Inc.  All rights reserved.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//
#ifndef __STDISO_H
#error include 'stdISO.h' before including this file
#endif
class AcmSurfTextStdBSI;

class STDIMP_DLLSHARE AcmStandardBSI : public AcmStandard
{
public:
  ACRX_DECLARE_MEMBERS(AcmStandardBSI);

  AcmStandardBSI();
  virtual ~AcmStandardBSI();
  
  virtual LPCTSTR originalName() const;             
  virtual Adesk::Boolean acmInit();             

  virtual void getTextHeightList(AcGeDoubleArray& txtArr) const;

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Adesk::Boolean setDimDefaults();

protected:
  virtual void initArrowServices();
  virtual Adesk::Boolean createDefaultStyle();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmStandardBSI);


class STDIMP_DLLSHARE AcmSurfTextStdBSI : public AcmSurfTextStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdBSI);

  AcmSurfTextStdBSI();
  virtual ~AcmSurfTextStdBSI();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual void initToEditOriginal();
  virtual void initToEdit();

  virtual Adesk::Boolean setFactoryDefaults();

  virtual Adesk::Boolean getLaySymbolList(AcmCObjArray<AcmCSymbolDesc>& list,
                                          const AcmCSurfText* pSubSym =NULL) const;

  virtual Acm::ErrorStatus checkVisibility(AcmCSurfText* pData) const;
  virtual Acm::ErrorStatus initFields(AcmCSurfText* pData) const ;
  virtual Acm::ErrorStatus setSuggested(AcmCSurfText* pData) const;

  virtual bool getSubEntsProd1(const AcmCSurfText* pSubSym,
                               AcmCAuxEntArray& subents,
                               AcDbExtents& fullExtent,
                               double txtHeight,
                               double& commonWidth,
                               AcGePoint3d& refPoint) const;
  virtual bool getSubEntsSampLen(const AcmCSurfText* pSubSym,
                                 AcmCAuxEntArray& subents,
                                 AcDbExtents& fullExtent,
                                 double txtHeight,
                                 double& commonWidth,
                                 AcGePoint3d& refPoint) const;
  virtual bool getSubEntsRaMax(const AcmCSurfText* pSubSym,
                               AcmCAuxEntArray& subents,
                               AcDbExtents& fullExtent,
                               double txtHeight,
                               double& commonWidth,
                               AcGePoint3d& refPoint,
                               Adesk::Boolean isOnlyRaValue) const;
  virtual bool getSubEntsRaMin(const AcmCSurfText* pSubSym,
                               AcmCAuxEntArray& subents,
                               AcDbExtents& fullExtent,
                               double txtHeight,
                               double& commonWidth,
                               AcGePoint3d& refPoint,
                               Adesk::Boolean isOnlyRaValue) const;

  virtual Acad::ErrorStatus getVarFromDlgIndex(Adesk::UInt8 dlgIndex, Acm::Variable& var) const;
  virtual AcmSurfTextStd::ConfigListState checkConfigListState(Acm::Variable var, CVarDlgInfo& varDlgInfo) const;

protected:
  virtual void getHeights(const AcmCSurfText* pSymb,
                          double& H1,
                          double& H2) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdBSI);


class STDIMP_DLLSHARE AcmSurfTextStdBSI2002 : public AcmSurfTextStdBSI
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdBSI2002);

  AcmSurfTextStdBSI2002();
  virtual ~AcmSurfTextStdBSI2002();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Adesk::Boolean getLaySymbolList(AcmCObjArray<AcmCSymbolDesc>& list,
                                          const AcmCSurfText* pSubSym =NULL) const;

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual void initToEditOriginal();
  virtual void initToEdit();

  virtual Acad::ErrorStatus getVarFromDlgIndex(Adesk::UInt8 dlgIndex, Acm::Variable& var) const;
  virtual AcmSurfTextStd::ConfigListState checkConfigListState(Acm::Variable var, CVarDlgInfo& varDlgInfo) const;
  virtual Acm::ErrorStatus checkVisibility(AcmCSurfText* pData) const;
  virtual Acm::ErrorStatus initFields(AcmCSurfText* pData) const ;
  virtual Acm::ErrorStatus setSuggested(AcmCSurfText* pData) const;
  virtual void restoreAllSuggestedList();
  virtual void getDefaultLaySymbols(AcDbIntArray& symArray) const;
  virtual void getDefaultVarSuggestList(Acm::Variable var, CStringList& list) const;

  virtual bool getSubEntsProd1(const AcmCSurfText* pSubSym,
                               AcmCAuxEntArray& subents,
                               AcDbExtents& fullExtent,
                               double txtHeight,
                               double& commonWidth,
                               AcGePoint3d& refPoint) const;

protected:
  virtual void getHeights(const AcmCSurfText* pSymb,
                          double& H1,
                          double& H2) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdBSI2002);


class STDIMP_DLLSHARE AcmFCFStdBSI : public AcmFCFStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmFCFStdBSI);

  AcmFCFStdBSI();             
  virtual ~AcmFCFStdBSI();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean setFactoryDefaults();
  virtual void initToEditOriginal();
  virtual void initToEdit();

  virtual Adesk::Boolean getMat(AcmCObjArray<AcmCGDTSymbolDesc>& list) const;

  virtual Acm::ErrorStatus checkVisibility(AcmCFCF* pData) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmFCFStdBSI);


class STDIMP_DLLSHARE AcmWeldingStdBSI : public AcmWeldingStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmWeldingStdBSI);

  AcmWeldingStdBSI();
  virtual ~AcmWeldingStdBSI();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Acm::ErrorStatus cInit();             
  virtual Adesk::Boolean setFactoryDefaults();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmWeldingStdBSI);


class STDIMP_DLLSHARE AcmDatumStdBSI : public AcmDatumStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmDatumStdBSI);

  AcmDatumStdBSI(); 
  virtual ~AcmDatumStdBSI();
	
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus cInit();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmDatumStdBSI);


class STDIMP_DLLSHARE AcmIdStdBSI : public AcmIdStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmIdStdBSI);
  
  AcmIdStdBSI();
  virtual ~AcmIdStdBSI();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmIdStdBSI);


class STDIMP_DLLSHARE AcmCPartListStdBSI : public AcmCPartListStd
{
public:
  AcmCPartListStdBSI(AcmBOMStd *std);
  virtual ~AcmCPartListStdBSI();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
};

class STDIMP_DLLSHARE AcmCBalloonStdBSI : public AcmCBalloonStd
{
public:
  AcmCBalloonStdBSI(AcmBOMStd *std);
  virtual ~AcmCBalloonStdBSI();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
};


class STDIMP_DLLSHARE AcmBOMStdBSI : public AcmBOMStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmBOMStdBSI);

  AcmBOMStdBSI();
  virtual ~AcmBOMStdBSI();

  virtual Acm::ErrorStatus cInit();
  virtual Adesk::Boolean setFactoryDefaults();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmBOMStdBSI);

#endif // STDBSI
